module Masshtab
  class DeployGenerator < Rails::Generators::Base
    source_root File.expand_path('../templates', __FILE__)

    argument :user_name, type: :string, desc: 'Name of an user who has access to the project'
    argument :server_name, type: :string, desc: 'Name or IP-address of the server'

    class_option :repository, type: :string, desc: 'Full address of the git repository. If empty server name and application name will be used'
    class_option :branch, type: :string, default: 'master', desc: 'Branch name to deploy from'

    application_name = Rails.application.class.parent_name.underscore
    class_option :application_name, type: :string, default: application_name, desc: 'Name of rails application'

    def configure_production
      application 'config.assets.precompile += %w(*.js *.css)', env: :production
    end

    def add_gems
      gem 'mysql2'
      gem 'unicorn'
      gem 'capistrano'
      gem 'therubyracer'
    end

    def copy_files
      template 'Capfile', Rails.root.join('Capfile')
      template 'unicorn.rb', Rails.root.join('config', 'unicorn.rb')
      template 'deploy.rb', Rails.root.join('config', 'deploy.rb')
    end

  end
end
